//////////////////////////////////////////////////////////
//r23toolbar by Gerald Kogler >>> http://yuri.at/go/r23///
//////////////////////////////////////////////////////////

//streams from streamring -> add your own streaming server to array 
//server must offer the file streamslist.xsl with format like:
//[mount]/kehuelga.mp3 [server_name]kehuelga radio 102.9 MHz FM [bitrate] 32kbps [listeners]0 [source_ip]132.248.109.85 
//in a near future that shood work through yellow pages format: http://r23.cc/community/?q=node/500
const str_streamlistall = new Array("http://dyne.org:8000", "http://giss.labbs.net:8000", "http://flux.bek.no:8000", "http://sputnik.psand.net:8000");
//temporarly not available
//"http://royalrabbit.goto10.org:9999", "http://pdradio.iem.at:8000",
//the following server are in the streamring but don't offer file streamslist.xsl
//"http://live1.radiovague.com", "http://radio.indymedia.org", "http://stream.sonance.net", "http://stream.kunstlabor.at", "http://hackitectura.net", "http://famipow.radio404.org", "http://195.178.229.102",

//don't change this settings
const str_streamlist_r23 = new String("http://stream.r23.cc:2323");
const str_mountpoint = new String("http://r23.cc/playstream.php?filetype=m3u&mountpoint=");
const str_streamlist = new String("/streamslist.xsl");
const str_mount = new String("[mount]");
const str_servername = new String("[server_name]");
const str_bitrate = new String("[bitrate]");
const str_listeners = new String("[listeners]");
const str_ip = new String("[source_ip]");
const str_live = new String("riereta");
const timeout = 300000;	// 300 secs == 5 min
var manReload = 0;	//don't set timeout if manually reloading streamslist

var streams_r23 = new Array();	//r23 streams
var streams_ring = new Array();	//streams from streamring
function Stream(stream,format,label,servername,bitrate,listeners,ip,cat) {
	this.stream = stream;
	this.format = format;
	this.label = label;
	this.servername = servername;
	this.bitrate = bitrate;
	this.listeners = listeners;
	this.ip = ip;
	this.cat = cat;
}

function setMutationEvent(){
	document.getElementById("r23tb").addEventListener("DOMAttrModified", AttributeNodeModified, false);
}

function AttributeNodeModified(evt)
{
	if (evt.attrName == "collapsed" && !evt.newValue){
		readStreamslist();
	}
}

//read urls for streams
function readStreamslist(){
	document.getElementById("loadImg").setAttribute("src","chrome://r23toolbar/content/Throbber.gif");
	var hidden = document.getElementById("r23tb").getAttribute("collapsed");
	if (!hidden){
		//init r23 streams
		removeOldList_r23();
		readRemoteStreamslist(str_streamlist_r23);
		//init streamring
		removeOldList_ring();
		for (var i = 0; i < str_streamlistall.length; i++){
			readRemoteStreamslist(str_streamlistall[i]);
		}
		//check if at least 1 stream was found
		/*
		if (streams_r23.length == 0){
			addListItemEmpty(str_streamlist_r23);
		}	
		if (streams_ring.length == 0){
			addListItemEmpty();
		}
		*/
	}
	//reload streams every x seconds
	if (manReload == 0){
		//alert("rebuild streamlist in every "+timeout+" ms.");
		setTimeout("readStreamslist()",timeout);
	} else{
		manReload=0;
	}
}

//make ajax connnection to streams
function readRemoteStreamslist(streamlist){
	//alert(streamlist);
	var req = new XMLHttpRequest();
	req.open('GET', streamlist+str_streamlist, true);
	req.onreadystatechange = function (aEvt) {
		if (req.readyState == 4) {
			if(req.status == 200)
				//alert(req.responseXML);
				readXMLStreamslist(req.responseText,streamlist);
			//else
				//alert("Error loading page:"+streamlist+str_streamlist+"\n");
		}
	};
	req.send(null);
}

//split stream info
function readXMLStreamslist(textfile,sel_streamlist){
	//alert("read:"+textfile);
	var lines = textfile.split(String.fromCharCode(10));
	for (var i = 0; i < lines.length; i++){
		if (lines[i].indexOf(str_mount) != -1){
			//alert(lines[i]);
			decodeStreamline(lines[i],sel_streamlist);
		}
	}
	document.getElementById("loadImg").setAttribute("src","chrome://r23toolbar/content/Throbber.png");
}

//decode stream info
function decodeStreamline(line,sel_streamlist){
	//get streampoint
	var start = line.indexOf(str_mount)+str_mount.length;
	var end = line.indexOf(str_servername);
	var stream = line.substring(start,end);
	var dot = stream.lastIndexOf(".");
	var label = stream.substring(1,dot);
	var format = stream.substring(dot+1,stream.length-1);
	//get servername
	start = end+str_servername.length;
	end = line.indexOf(str_bitrate);
	var servername = line.substring(start,end);
	//get bitrate
	start = end+str_bitrate.length;
	end = line.indexOf(str_listeners);
	var bitrate = line.substring(start,end);
	//get listeners
	start = end+str_listeners.length;
	end = line.indexOf(str_ip);
	if (end == -1){
		var listeners = line.substring(start,start+1);
	} else{
		var listeners = line.substring(start,end);
	}
	//get ip
	start = end+str_ip.length;
	if (end != -1){
		end = line.length;
		var ip = line.substring(start,end);
	} else{
		var ip = "";
	}
	//format changed! (8.9.2006)
	var stream = stream.substring(0,stream.length-1);
	//alert(format+":::"+label+":::"+servername+":::"+bitrate+":::"+listeners+":::"+ip);
	addListItem(stream,format,label,servername,bitrate,listeners,ip,sel_streamlist);
	//save streaminfo
	var newStream = new Stream(stream,format,label,servername,bitrate,listeners,ip,sel_streamlist);
	if (sel_streamlist == str_streamlist_r23){
		streams_r23.push(newStream);
	} else{
		streams_ring.push(newStream);
	}
}

//create list item with given stream
function addListItem(stream,format,label,servername,bitrate,listeners,ip,sel_streamlist){
	if (sel_streamlist == str_streamlist_r23){
		var streamlist = document.getElementById("streamlistr23");
	} else{
		var streamlist = document.getElementById("streamlistring");
	}
	var streamitem = document.createElement("menuitem");
	streamitem.setAttribute("label",label+" - "+servername+" ("+bitrate+")");
	streamitem.setAttribute("tooltiptext","listen to stream "+label+" - "+servername);
	//format changed! (8.9.2006)
	//streamitem.setAttribute("value"," "+str_mountpoint+sel_streamlist+stream);
	streamitem.setAttribute("value"," "+sel_streamlist+stream+".m3u");
	streamitem.setAttribute("id",streamlist.childNodes.length);
	if (sel_streamlist == str_streamlist_r23){
		streamitem.setAttribute("onclick",'setInfo(streams_r23[id]);openStream(value)');
		//show live button
		if (label.indexOf(str_live) != -1){
			var livebutton = document.getElementById("live");
			livebutton.setAttribute("hidden",false);
			livebutton.setAttribute("tooltiptext","listen to stream "+label+" - "+servername);
			livebutton.setAttribute("id",streamlist.childNodes.length);
			livebutton.setAttribute("onclick",'setInfo(streams_r23[id]);openStreamId(id)');
		}
	} else{
		streamitem.setAttribute("onclick",'setInfo(streams_ring[id]);openStream(value)');
	}
	streamitem.setAttribute("class","menuitem-iconic");
	if (format == "ogg"){
		streamitem.setAttribute("image","chrome://r23toolbar/content/actiu_ogg.png");
	} else if (format == "mp3"){
		streamitem.setAttribute("image","chrome://r23toolbar/content/actiu_mp3.png");
	}
	streamlist.appendChild(streamitem);
}

//create list item with given stream
function addListItemEmpty(streamtype){
	if (streamtype == str_streamlist_r23){
		var streamlist = document.getElementById("streamlistr23");
	} else{
		var streamlist = document.getElementById("streamlistring");
	}
	var streamitem = document.createElement("menuitem");
	streamitem.setAttribute("label","no stream available");
	streamitem.setAttribute("tooltiptext","reload in 60 seconds");
	streamitem.setAttribute("id",streamlist.childNodes.length);
	streamlist.appendChild(streamitem);
}

//empty r23 list for reload
function removeOldList_r23(){
	streams_r23 = new Array();
	var items = document.getElementById("streamlistr23");
	if (items != null){
		while (items.hasChildNodes()){
			items.removeChild(items.firstChild);
		}
	}
}

//empty ring list for reload
function removeOldList_ring(){
	streams_ring = new Array();
	var items = document.getElementById("streamlistring");
	if (items != null){
		while (items.hasChildNodes()){
			items.removeChild(items.firstChild);
		}
	}
}

//load webpage
function loadURL(URL){
	window._content.document.location = URL;
	window.content.focus();
}

//open stream in external player
function openStream(stream){
	//alert("open stream:"+stream);
	window.open(stream,'_self');
}

//open stream in external player
function openStreamId(id){
	openStream(str_mountpoint+str_streamlist_r23+streams_r23[id].stream);
}

//show info of selected stream in toolbar
function setInfo(activeStream){
	//alert(activeStream.format+":::"+activeStream.label+":::"+activeStream.servername+":::"+activeStream.bitrate+":::"+activeStream.listeners+":::"+activeStream.ip);
	var infobox = document.getElementById("infobox");
	if (infobox.getAttribute("hidden")){
		infobox.setAttribute("hidden", false);
	}
	var info_format = document.getElementById("info_format");
	if (activeStream.format == "ogg"){
		info_format.setAttribute("src","chrome://r23toolbar/content/actiu_ogg.png");
	} else if (activeStream.format == "mp3"){
		info_format.setAttribute("src","chrome://r23toolbar/content/actiu_mp3.png");
	}
	info_format.setAttribute("class","icon_size");
	var info_stream = document.getElementById("info_stream");
	info_stream.setAttribute("value", activeStream.label+" - "+activeStream.servername);
	var info_ip = document.getElementById("info_ip");
	info_ip.setAttribute("value", activeStream.ip);
	var info_bitrate = document.getElementById("info_bitrate");
	info_bitrate.setAttribute("value", activeStream.bitrate);
	var info_listeners = document.getElementById("info_listeners");
	info_listeners.setAttribute("value", activeStream.listeners);
	//adapt button and tooltip
	var playitem = document.getElementById("playing");
	//playitem.setAttribute("tooltiptext",str_mountpoint+activeStream.cat+activeStream.stream);
	playitem.setAttribute("tooltiptext",activeStream.cat+activeStream.stream+".m3u");
	playitem.setAttribute("onclick","openStream(this.getAttribute('tooltiptext'))");
}

//PREFS
function initPath(){
	var prefservice = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
	var prefs = prefservice.getBranch("");

	//get pref active
	var active = null;
	if (prefs.getPrefType("active") == prefs.PREF_STRING){
		active = prefs.getCharPref("active");
	}
	if ((active != null) && (active.length > 0)){
		document.getElementById('active').value = active;
	}

	//get pref time
	var time = null;
	if (prefs.getPrefType("time") == prefs.PREF_STRING){
		time = prefs.getCharPref("time");
	}
	if ((time != null) && (time.length > 0)){
		document.getElementById('time').value = time;
	}
	prefs = null;
}

function setr23Options(){
	var prefService = Components.classes["@mozilla.org/preferences-service;1"]
	getService(Components.interfaces.nsIPrefService);
	var prefs = prefService.getBranch("");
	prefs.setCharPref("active", document.getElementById('active').value);
	prefs.setCharPref("time", document.getElementById('time').value);
	window.close();
}

//set time to default
function prefSetDefaultTime(){
	var prefTime = document.getElementById("time");
	playTime.setAttribute("value","60");
}

//reload streamslist manually
function reloadStreamslist(){

	readStreamslist();
	setTimeout("readStreamslist()",timeout);
}
